package net.roseindia;

import java.util.List;
import java.util.Map;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.boot.registry.StandardServiceRegistry;
import org.hibernate.boot.registry.StandardServiceRegistryBuilder;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;
import org.hibernate.service.ServiceRegistryBuilder;

public class HibernateNativeScalarQuery {
	private static SessionFactory sf;
	private static ServiceRegistry serviceRegistry;

	public static void main(String[] args) {
		try {
			/*
			Configuration configuration = new Configuration();
			configuration.configure()
					.setProperty("hibernate.show_sql", "false");
			;
			serviceRegistry = new ServiceRegistryBuilder().applySettings(
					configuration.getProperties()).buildServiceRegistry();
			sf = configuration.buildSessionFactory(serviceRegistry);
			*/
			Configuration cfg = new Configuration().configure("hibernate.cfg.xml");        	

        	StandardServiceRegistryBuilder sb = new StandardServiceRegistryBuilder();
        	
        	sb.applySettings(cfg.getProperties());
        	
        	StandardServiceRegistry standardServiceRegistry = sb.build();           	
        	
        	sf = cfg.buildSessionFactory(standardServiceRegistry);
        	
        	
		} catch (Throwable ex) {
			System.err.println("Failed to create sessionFactory object." + ex);
			throw new ExceptionInInitializerError(ex);
		}
		System.out.println("***Hibernate Native Scalar Query Example***");
		System.out.println("-------------------------------------------");
		Session session = sf.openSession();
		try {
			session.beginTransaction();
			String sql = "SELECT firstname, birth_date,cell_phone FROM worker";
			Query query = session.createSQLQuery(sql);
			query.setResultTransformer(Criteria.ALIAS_TO_ENTITY_MAP);
			List data = query.list();

			for (Object object : data) {
				Map row = (Map) object;
				System.out.println("First Name: " + row.get("firstname"));
				System.out.println("Birth Date: " + row.get("birth_date"));
				System.out.println("Cell Phone: " + row.get("cell_phone"));
				System.out
						.println("-------------------------------------------");
			}
			session.getTransaction().commit();
		} catch (HibernateException e) {
			if (session.getTransaction() != null)
				session.getTransaction().rollback();
			e.printStackTrace();
		} finally {
			session.close();
		}
	}
}
